function [mls] = make_sig_mls_helper (n, fs)
%Create MLS sequence.
%- Add credit
%- I have added pink MLS noise below by dividing FFT amplides by k, where
%   k is wavenumber.

N=2^n-1;        % number of samples in 1 MLS

switch n
case 8
   tap1=6; tap2=5; tap3=1;
case 9
   tap1=4;% tap2=n-tap1; %reversed sequence
case 10
   tap1=3;% tap2=n-tap1; %reversed sequence
case 11
   tap1=2;% tap2=n-tap1; %reversed sequence
case 12
   tap1=11; tap2=10; tap3=2;
case 13
   tap1=4; tap2=3; tap3=1;
case 14
   tap1=12; tap2=11; tap3=1;
case 15 
   tap1=8; tap2=11; %these are two different sequences
case 16 
   tap1=5; tap2=3; tap3=2;
case 17  % prime number fft
   tap1=3;% tap2=n-tap1; %reversed sequence
case 18
   tap1=7;% tap2=n-tap1; %reversed sequence
case 19  % prime number fft
   tap1=6; tap2=5; tap3=1;
case 20
   tap1=17;% tap2=n-tap1; %reversed sequence
case 21
   tap1=2;% tap2=n-tap1; %reversed sequence
end % MLS order
% Each mls() is a shift register value, then its MSB is mapped to bipolar output
mls=zeros(1,N);
mls(1) = N; %start with all 1's state
if n==8||n==12||n==13||n==14||n==16||n==19 %these all require 4 taps
    for i = 1:N-1  %double the register, project out lowest n bits, add xor feedback
	x1=xor(bitget(mls(i),n),bitget(mls(i),tap1));
    x2=xor(bitget(mls(i),tap2),bitget(mls(i),tap3));
    mls(i+1) = bitand(2*mls(i),N) + xor(x1,x2);
    end
    else
    for i = 1:N-1  %double the register, project out lowest n bits, add xor feedback
	mls(i+1) = bitand(2*mls(i),N) + xor(bitget(mls(i),n),bitget(mls(i),tap1));
    end
end % 4-tap
%mls = 1-2*bitget(mls,n)';  %standard map; zeros become +1, ones become -1
mls = 1-2*bitget(mls,n);  % OCTAVE.  TRANSPOSE NOT NEEDED!

mls=transpose(mls);


